ServerEvents.recipes(event => {
    event.shapeless(
        Item.of('powah:dielectric_paste', 64), 
        [
          'minecraft:clay_ball',
          'bigreactors:cyanite_ingot',
          'minecraft:black_dye'
        ]
      )
      function Duping(ItemToDupe) {
        event.shapeless(
          Item.of(ItemToDupe, 2),
        [
          ItemToDupe
        ]
      )
    }
    Duping('pipez:infinity_upgrade')
    Duping('mekanism:creative_fluid_tank')
    Duping('functionalstorage:creative_vending_upgrade')
    Duping('mekanism:creative_chemical_tank')
    Duping('cyclic:battery_infinite')
      event.shapeless(
        Item.of('kubejs:supreme_fragment', 9), 
        [
          'kubejs:supreme_block'
        ]
      )
      function ClearNBT(ItemToClear) {
        event.shapeless(
          Item.of(ItemToClear, 1),
        [
          ItemToClear
        ]
      )
    }
    ClearNBT('draconicevolution:basic_crafting_injector')
    ClearNBT('draconicevolution:wyvern_crafting_injector')
    ClearNBT('draconicevolution:awakened_crafting_injector')
    ClearNBT('mekanism:osmium_compressor')
    ClearNBT('mekanism:pressurized_reaction_chamber')
    ClearNBT('mekanism:electrolytic_separator')
    ClearNBT('mekanism:rotary_condensentrator')
      event.shaped(
        Item.of('kubejs:supreme_block', 1),
        [
          'AAA',
          'AAA',
          'AAA'
        ],
        {
          A: 'kubejs:supreme_fragment'
        }
      )
    event.shaped(
        Item.of('thermal:machine_frame', 1),
        [
          'ABA',
          'BCB',
          'ABA'
        ],
        {
          A: '#forge:dusts/lithium',
          B: 'mekanism:ultimate_control_circuit',
          C: 'mekanism:hdpe_sheet'
        }
      )
      event.shaped(
        Item.of('bigreactors:reprocessorcasing', 8),
        [
          'ABA',
          'BCB',
          'ABA'
        ],
        {
          A: 'minecraft:iron_ingot',
          B: 'bigreactors:cyanite_ingot',
          C: 'minecraft:water_bucket'
        }
      )
      event.shaped(
        Item.of('bigreactors:fluidizercasing', 4),
        [
          'ABA',
          'BCB',
          'ABA'
        ],
        {
          A: 'minecraft:iron_ingot',
          B: '#forge:ingots/uranium',
          C: 'minecraft:water_bucket'
        }
      )
      event.shaped(
        Item.of('pipez:infinity_upgrade', 1),
        [
          'ABA',
          'BCB',
          'ABA'
        ],
        {
          A: 'allthecompressed:netherite_block_2x',
          B: 'allthecompressed:redstone_block_4x',
          C: 'pipez:ultimate_upgrade'
        }
      )
      event.shaped(
        Item.of('industrialforegoing:machine_frame_pity', 1),
        [
          'ABA',
          'BCB',
          'ABA'
        ],
        {
          A: 'powah:crystal_nitro',
          B: 'bigreactors:ludicrite_ingot',
          C: 'bigreactors:basic_reactorcontroller'
        }
      )
      event.shaped(
        Item.of('industrialforegoing:machine_frame_pity', 1),
        [
          'AAA',
          'BBB',
          'AAA'
        ],
        {
          A: 'minecraft:nether_star',
          B: 'kubejs:supreme_fragment'
        }
      )
      event.shaped(
        Item.of('bigreactors:basic_reactorcontroller', 1),
        [
          'AAA',
          'BCB',
          'AAA'
        ],
        {
          A: 'thermalendergy:melodium_plate',
          B: 'thermalendergy:endergy_upgrade_3',
          C: 'thermal:machine_frame'
        }
      )
      event.shaped(
        Item.of('alchemistry:dissolver', 1),
        [
          'ABA',
          'CDC',
          'EBE'
        ],
        {
          A: 'mekanismgenerators:advanced_solar_generator',
          B: 'minecraft:piston',
          C: 'mekanism:hydrofluoric_acid_bucket',
          D: 'industrialforegoing:machine_frame_supreme',
          E: 'cyclic:charm_fire'
        }
      )
      event.shaped(
        Item.of('alchemistry:compactor', 1),
        [
          'ABA',
          'CDC',
          'ABA'
        ],
        {
          A: 'chemlib:tungsten',
          B: 'minecraft:piston',
          C: 'mekanism:ultimate_combining_factory',
          D: 'mekanism:ultimate_infusing_factory'
        }
      )
      event.shaped(
        Item.of('draconicevolution:draconium_core', 4),
        [
          'ABA',
          'DCD',
          'ABA'
        ],
        {
          A: 'draconicevolution:draconium_block',
          B: 'ae2:cell_component_4k',
          C: 'kubejs:supreme_fragment',
          D: 'refinedstorage:4k_storage_part'
        }
      )
      event.shaped(
        Item.of('culinaryconstruct:culinary_station', 1),
        [
          ' A ',
          ' B '
        ],
        {
          A: 'functionalstorage:creative_vending_upgrade',
          B: 'minecraft:crafting_table'
        }
      )
      event.shaped(
        Item.of('kubejs:ultimate_sword', 1),
        [
          ' A ',
          'BCD',
          ' E '
        ],
        {
          A: 'kubejs:bread_sword',
          B: 'bhc:blade_of_vitality',
          C: 'draconicevolution:draconic_sword',
          D: 'mekaweapons:mekatana',
          E: 'minecraft:trident'
        }
      )
      event.shaped(
        Item.of('kubejs:ultimate_sword', 1),
        [
          ' A ',
          'BCD',
          ' E '
        ],
        {
          A: 'kubejs:bread_sword',
          B: 'bhc:blade_of_vitality',
          C: 'draconicevolution:draconic_sword',
          D: 'mekaweapons:mekatana',
          E: 'minecraft:trident'
        }
      )
      event.shaped(
        Item.of('avaritia:longbowofthe_heavens', 1),
        [
          ' AC',
          'B C',
          ' DC'
        ],
        {
          A: 'cyclic:laser_cannon',
          B: 'mekaweapons:mekabow',
          C: 'minecraft:string',
          D: 'draconicevolution:draconic_bow'
        }
      )
      event.shaped(
        Item.of('avaritia:infinity_armor_helmet', 1),
        [
          'ABA',
          'ACA',
          'ADA'
        ],
        {
          A: 'chemlib:tungsten_plate',
          B: 'pipez:infinity_upgrade',
          C: 'mekanism:mekasuit_helmet',
          D: 'cyclic:crystal_helmet'
        }
      )
      event.shaped(
        Item.of('avaritia:infinity_armor_chestplate', 1),
        [
          'ABA',
          'ACA',
          'ADA'
        ],
        {
          A: 'chemlib:tungsten_plate',
          B: 'pipez:infinity_upgrade',
          C: 'mekanism:mekasuit_bodyarmor',
          D: 'cyclic:crystal_chestplate'
        }
      )
      event.shaped(
        Item.of('avaritia:infinity_armor_leggings', 1),
        [
          'ABA',
          'ACA',
          'ADA'
        ],
        {
          A: 'chemlib:tungsten_plate',
          B: 'pipez:infinity_upgrade',
          C: 'mekanism:mekasuit_pants',
          D: 'cyclic:crystal_leggings'
        }
      )
      event.shaped(
        Item.of('avaritia:infinity_armor_boots', 1),
        [
          'ABA',
          'ACA',
          'ADA'
        ],
        {
          A: 'chemlib:tungsten_plate',
          B: 'pipez:infinity_upgrade',
          C: 'mekanism:mekasuit_boots',
          D: 'cyclic:crystal_boots'
        }
      )
      event.shaped(
        Item.of('avaritia:infinity_ingot', 1),
        [
          'A B',
          'C D',
          'E F'
        ],
        {
          A: 'avaritia:infinity_armor_helmet',
          B: 'avaritia:infinity_armor_leggings',
          C: 'avaritia:swordofthe_cosmos',
          D: 'avaritia:longbowofthe_heavens',
          E: 'avaritia:infinity_armor_chestplate',
          F: 'avaritia:infinity_armor_boots'
        }
      )
      event.shaped(
        Item.of('hostilenetworks:prediction_matrix', 16),
        [
          ' A ',
          'BCD',
          ' E '
        ],
        {
          A: 'minecraft:rotten_flesh',
          B: 'minecraft:spider_eye',
          C: 'minecraft:clay_ball',
          D: 'minecraft:bone',
          E: 'minecraft:gunpowder'
        }
      )
      event.shaped(
        Item.of('kubejs:1x_compressed_bread', 1),
        [
          'AAA'
        ],
        {
          A: 'minecraft:bread'
        }
      )
      event.shaped(
        Item.of('kubejs:2x_compressed_bread', 1),
        [
          'AAA'
        ],
        {
          A: 'kubejs:1x_compressed_bread'
        }
      )
      event.shaped(
        Item.of('kubejs:3x_compressed_bread', 1),
        [
          'AAA'
        ],
        {
          A: 'kubejs:2x_compressed_bread'
        }
      )
      event.shaped(
        Item.of('kubejs:4x_compressed_bread', 1),
        [
          'AAA'
        ],
        {
          A: 'kubejs:3x_compressed_bread'
        }
      )
      event.shaped(
        Item.of('kubejs:5x_compressed_bread', 1),
        [
          'AAA'
        ],
        {
          A: 'kubejs:4x_compressed_bread'
        }
      )
      event.shaped(
        Item.of('kubejs:black_hole_bread', 1),
        [
          'AAA'
        ],
        {
          A: 'kubejs:5x_compressed_bread'
        }
      )
      event.shaped(
        Item.of('kubejs:bread_sword', 1),
        [
          'A',
          'A',
          'B'
        ],
        {
          A: 'kubejs:black_hole_bread',
          B: 'minecraft:stick'
        }
      )
      event.shaped(
        Item.of('fluxnetworks:flux_dust', 8),
        [
          'AAA',
          'ABA',
          'AAA'
        ],
        {
          A: 'minecraft:redstone',
          B: 'minecraft:obsidian'
        }
      )
      event.shaped(
        Item.of('bigreactors:reinforced_reactorcontroller', 1),
        [
          'AAA',
          'ABA',
          'AAA'
        ],
        {
          A: 'bigreactors:reinforced_reactorcasing',
          B: 'bigreactors:basic_reactorcontroller'
        }
      )
      event.shaped(
        Item.of('industrialforegoing:laser_drill', 1),
        [
          'ABA',
          'CDC',
          'EFE'
        ],
        {
          A: 'industrialforegoing:plastic',
          B: 'thermal:diamond_gear',
          C: 'minecraft:piston',
          D: 'minecraft:diamond_pickaxe',
          E: '#forge:gears/gold',
          F: 'minecraft:redstone'
        }
      )
      event.custom(
        {
          type: 'draconicevolution:fusion_crafting',
          catalyst: {
            item: 'functionalstorage:netherite_upgrade'
          },
          ingredients: [
            {
              item: 'mekanism:creative_fluid_tank'
            },
            {
              item: 'mekanism:creative_chemical_tank'
            },
            {
              item: 'avaritia:infinity_ingot'
            },
            {
              item: 'bigreactors:ludicrite_block'
            },
            {
              item: 'chemlib:protactinium_metal_block'
            },
            {
              item: 'mekanism:pellet_antimatter'
            },
            {
              item: 'pipez:infinity_upgrade'
            },
            {
              item: 'cyclic:battery_infinite'
            },
            {
              item: 'kubejs:supreme_block'
            },
            {
              item: 'apotheosis:ender_library'
            },
            {
              item: 'minecraft:totem_of_undying'
            },
            {
              item: 'allthecompressed:nitro_crystal_block_4x'
            }
          ],
          result: {
            item: 'functionalstorage:creative_vending_upgrade'
          },
          tier: 'CHAOTIC',
          total_energy: 2147483647
        }
      )
      event.custom(
        {
          type: 'draconicevolution:fusion_crafting',
          catalyst: {
            item: 'mekanism:ultimate_fluid_tank'
          },
          ingredients: [
            {
              item: 'extradisks:infinite_fluid_storage_block'
            },
            {
              item: 'trashcans:liquid_trash_can'
            },
            {
              item: 'kubejs:supreme_block'
            },
            {
              item: 'bigreactors:ludicrite_block'
            },
            {
              item: 'chemlib:protactinium_metal_block'
            },
            {
              item: 'megacells:fluid_storage_cell_256m'
            }
          ],
          result: {
            item: 'mekanism:creative_fluid_tank'
          },
          tier: 'CHAOTIC',
          total_energy: 2147483647
        }
      )
      event.custom(
        {
          type: 'draconicevolution:fusion_crafting',
          catalyst: {
            item: 'powah:energy_cell_nitro'
          },
          ingredients: [
            {
              item: 'fluxnetworks:gargantuan_flux_storage'
            },
            {
              item: 'mekanism:ultimate_induction_provider'
            },
            {
              item: 'kubejs:supreme_block'
            },
            {
              item: 'bigreactors:ludicrite_block'
            },
            {
              item: 'chemlib:protactinium_metal_block'
            },
            {
              item: 'trashcans:energy_trash_can'
            }
          ],
          result: {
            item: 'cyclic:battery_infinite'
          },
          tier: 'CHAOTIC',
          total_energy: 2147483647
        }
      )
      event.custom(
        {
          type: 'draconicevolution:fusion_crafting',
          catalyst: {
            item: 'mekanism:ultimate_chemical_tank'
          },
          ingredients: [
            {
              item: 'ae2additions:disk_chemical_65536k'
            },
            {
              item: 'mekanismgenerators:gas_burning_generator'
            },
            {
              item: 'kubejs:supreme_block'
            },
            {
              item: 'bigreactors:ludicrite_block'
            },
            {
              item: 'chemlib:protactinium_metal_block'
            }
          ],
          result: {
            item: 'mekanism:creative_chemical_tank'
          },
          tier: 'CHAOTIC',
          total_energy: 2147483647
        }
      )
      event.custom(
        {
          type: 'apotheosis:enchanting',
          conditions: [{
            type: 'apotheosis:module',
            module: 'enchantment'
          }],
          input: {
            item: 'kubejs:ultimate_sword'
          },
          requirements: {
            eterna: 50,
            quanta: 0,
            arcana: 100
          },
          max_requirements: {
            eterna: 50,
            quanta: 0,
            arcana: 100
          },
          result: {
            item: 'avaritia:swordofthe_cosmos',
            count: 1
          }
        }
      )
      event.recipes.thermal.smelter('refinedstorage:silicon', 'minecraft:quartz', 1, 2000)
      event.recipes.thermal.press('2x chemlib:tungsten_plate', 'chemlib:tungsten_metal_block', 60, 690000)  
      event.recipes.mekanism.combining('kubejs:supreme_block', 'industrialforegoing:machine_frame_supreme', 'chemlib:yttrium_metal_block')
      event.recipes.mekanism.crushing('thermal:nickel_dust', 'thermal:nickel_ingot')
      event.replaceInput(
        { input: 'bigreactors:yellorium_ingot' },
        'bigreactors:yellorium_ingot',
        '#forge:ingots/uranium'
      )
      event.replaceInput(
        { input: 'minecraft:bookshelf' },
        'minecraft:bookshelf',
        '#forge:bookshelves'
      )
      function EditInByOut(Filter, ChangeFrom, ChangeTo) {
        event.replaceInput(
          {output: Filter},
          ChangeFrom,
          ChangeTo
        )
      }
      EditInByOut('storagenetwork:master', 'minecraft:quartz', 'minecraft:redstone')
      EditInByOut('adminshop:buyer_1', 'minecraft:ender_chest', '#forge:chests/wooden')
})